#!/usr/bin/python3
# -*- coding: utf-8 -*-

from PyQt5.QtCore import *
from PyQt5.QtGui import *
from PyQt5.QtWidgets import QWidget, QLabel, QHBoxLayout, QVBoxLayout

from mainui.systembutton import *

import gettext
import sys

_=gettext.gettext

class UpdateSuccessWidget(QWidget):
    def __init__(self,parent=None):
        super(UpdateSuccessWidget,self).__init__(parent)
        self.setWindowFlags(Qt.FramelessWindowHint |Qt.WindowStaysOnTopHint|Qt.Tool)
        self.setAttribute(Qt.WA_TranslucentBackground)
        self.setFixedSize(320,220)
        self.setAutoFillBackground(True)
        palette = QPalette()
        palette.setColor(self.backgroundRole(), QColor(255,255,255))
        self.setPalette(palette)
        self.initui()
        self.mouse_press = False
        #self.show()

    def initui(self):
        #self.topwidget=top_widget(self.width(),self)
        #self.topwidget.move(0,0)
        self.tip_label = QLabel()
        self.tip_label.resize(95, 22)
        self.tip_quit_label = QLabel()
        self.tip_quit_label.resize(125, 12)
        self.close_btn = SystemButton(False,False,True,self)
        self.close_btn.setGeometry(276,14,30,30)


        #显示更新成功
        self.tip_label.setText(_("update success"))
        self.tip_label.setStyleSheet("QLabel{color:#3D6BE5;font-size:24px;}")
        self.tip_label.setWordWrap(True)
        #程序将在5秒后退出
        self.tip_quit_label.setText(_("Program will exit in 5 seconds"))
        self.tip_quit_label.setStyleSheet("QLabel{color:#888888;font-size:14px}")

        hlayout1 = QHBoxLayout()
        hlayout1.addStretch()
        hlayout1.addWidget(self.tip_label)
        hlayout1.addStretch()

        hlayout2 = QHBoxLayout()
        hlayout2.addStretch()
        hlayout2.addWidget(self.tip_quit_label)
        hlayout2.addStretch()

        vlayout = QVBoxLayout()
        vlayout.addStretch()
        vlayout.addLayout(hlayout1)
        vlayout.addSpacing(15)
        vlayout.addLayout(hlayout2)
        vlayout.addStretch()

        self.setLayout(vlayout)

    #
    # 函数：鼠标按下事件
    #

    def mousePressEvent(self, event):
        if (event.button() == Qt.LeftButton):
            self.mouse_press = True
            self.drag_pos = event.globalPos() - self.pos()
            event.accept()

    def mouseReleaseEvent(self, event):
        self.mouse_press = False
        self.setWindowOpacity(1)

    def mouseMoveEvent(self, event):
        if (self.mouse_press):
            self.move_pos = event.globalPos()
            self.move(self.move_pos - self.drag_pos)
            self.setWindowOpacity(1)
            event.accept()

    def paintEvent(self, event):
        # 阴影
        path = QPainterPath()
        path.setFillRule(Qt.WindingFill)
        pat = QPainter(self)
        pat.setRenderHint(pat.Antialiasing)
        # print(opt.palette.base().color())
        pat.fillPath(path, QBrush(Qt.white))

        color = QColor(0, 0, 0, 50)

        for i in range(10):

            i_path = QPainterPath()
            i_path.setFillRule(Qt.WindingFill)
            ref = QRectF(10 - i, 10 - i, self.width() - (10 - i) * 2, self.height() - (10 - i) * 2)
            if i == 0:
                pass
            else:
                i_path.addRoundedRect(ref, 0, 0)
                color.setAlpha(int(150 - i ** 0.5 * 50))
                pat.setPen(color)
                pat.drawPath(i_path)
        # pat.end()

        # 主题
        ref = QRectF(10, 10, self.width() - 20, self.height() - 20)
        p = QPainter(self)
        p.setRenderHint(QPainter.Antialiasing)
        p.setBrush(Qt.white)
        p.setPen(Qt.transparent)
        p.setPen(Qt.NoPen)
        # p.drawRect(opt.rect)
        p.drawRoundedRect(ref, 0, 0)

class top_widget(QWidget):
    def __init__(self,width,parent=None):
        super(top_widget,self).__init__(parent)
        self.setWindowFlags(Qt.FramelessWindowHint)
        self.setAutoFillBackground(True)
        self.resize(width,36)
        palette = QPalette()
        palette.setColor(self.backgroundRole(), QColor(255, 255, 255))
        self.setPalette(palette)
        self.initui()
        self.show()

    def initui(self):
        self.close_button = SystemButton(False,False,True,self)
        self.close_button.setGeometry(266,196,0,0)



