#!/usr/bin/python3
# -*- coding: utf-8 -*-

import os
import configparser
import shutil

class CustomConfigParser(configparser.ConfigParser):

    def __init__(self, defaults=None):
        configparser.ConfigParser.__init__(self, defaults=None)
    
    def optionxform(self, optionstr):
        return optionstr

#AUTOSTART_DIR = '/usr/share/upstart/xdg/autostart/'
AUTOSTART_DIR = '/etc/xdg/autostart/'
USER_DIR = os.path.expanduser('~/.config/autostart/')
FILE = 'kylin-update-manager-autostart.desktop'

class AutoStart():

    def __init__(self):
        pass

    def read_desktop_file(self):
        return True

    def check_current_status(self):
        if os.path.exists(USER_DIR + FILE):
            return False
        else:
            if os.path.exists(AUTOSTART_DIR + FILE):
                return True
            else:
                return False

    def set_autostart(self):
        path_str = USER_DIR + FILE
        status_bool = self.read_desktop_file()

        if status_bool:
            if os.path.exists(path_str):
                os.remove(path_str)
            else:
                pass

    def set_not_autostart(self):
        sour_str = AUTOSTART_DIR + FILE
        dest_str = USER_DIR + FILE
        status_bool = self.read_desktop_file()

        if status_bool:
            if not os.path.exists(USER_DIR):
                os.makedirs(USER_DIR)
            elif os.path.exists(dest_str):
                os.remove(dest_str)
            shutil.copy(sour_str, dest_str)

            #############set not autostart###########
            cf = CustomConfigParser()
            cf.read(dest_str)

            section = "Desktop Entry"
            option = "X-GNOME-Autostart-enabled"
            s = cf.sections()
            if section in s:
                cf.set(section, option, "false")
                cf.write(open(dest_str, "w"))


def interface_get():
    obj = AutoStart()
    return obj.check_current_status()

def interface_set(switch):
    obj = AutoStart()
    if switch:
        obj.set_autostart()
    else:
        obj.set_not_autostart()

    return True
    
